//
//  MMITreeMap.h
//  MMITreeMap
//
//  Created by Martin Redington on 23/01/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

//
//
//

@class MMITreeMapNode;
@class MMITreeMapSplitStrategy;

//
//
//

@interface MMITreeMap : NSObject {

    MMITreeMapNode *mActiveLeaf;

    // color provider
    // ColorProvider colorProvider = null;
    // displayed root

    MMITreeMapNode *mDisplayedRoot;
    // root of the tree
    
    MMITreeMapNode *mRoot;
    
    // divide strategy
    MMITreeMapSplitStrategy *mSplitStrategy;
    
    
    // tooltip builder
//    IToolTipBuilder toolTipBuilder;
//    // zoom
//    Zoom zoom;
    
}

//
//
//

- (id) initWithRoot:(MMITreeMapNode *) root;
- (id) initWithRoot:(MMITreeMapNode *) root splitStrategy:(MMITreeMapSplitStrategy *)splitStrategy;

- (void) calculatePositions;

- (MMITreeMapNode *)root;
- (void) setRoot:(MMITreeMapNode *)root;

- (MMITreeMapNode *)displayedRoot;
- (void) setDisplayedRoot:(MMITreeMapNode *)displayedRoot;

- (MMITreeMapSplitStrategy *) splitStrategy;
- (void) setSplitStrategy:(MMITreeMapSplitStrategy *) splitStrategy;

@end
