//
//  MMITreeMapView.h
//  MMITreeMap
//
//  Created by Martin Redington on 25/01/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

//
//
//

#define kMMITreeMapCalculatingPositionsNotification @"MMITreeMapCalculatingPositionsNotification"
#define kMMITreeMapCalculatedPositionsNotification @"MMITreeMapCalculatedPositionsNotification"
#define kMMITreeMapAnalyzingDataNotification @"MMITreeMapAnalyzingDataNotification"
#define kMMITreeMapAnalyzedDataNotification @"MMITreeMapAnalyzedDataNotification"

//
//
//

@class MMITreeMap;
@class MMITreeMapNode;
@class MMITreeMapColorProvider;
@class MMITreeMapProgressIndicator;

@class AMIndeterminateProgressIndicatorCell;

//
//
//

typedef enum MMITreeMapViewState {
    MMITreeMapViewNormalState = 0,
    MMITreeMapViewRecalculatingState = 1,
} MMITreeMapViewState;

//
//
//

@interface MMITreeMapView : NSView {
    MMITreeMapViewState mState;
//    NSProgressIndicator *mProgressIndicator;
//    AMIndeterminateProgressIndicatorCell *mAMProgressIndicator;
    MMITreeMapProgressIndicator *mProgressIndicator;
        
    MMITreeMap *mTreeMap;
    NSFont *mLabelFont;
    MMITreeMapNode *mActiveLeaf;
    BOOL mPositionsChangedCount;
    BOOL mPositionsCached;
    NSRect mPositionsCachedForRect;
    BOOL mJustRecalculated;
    BOOL mCalculatingPositions;
    BOOL mAnalyzingData;
    MMITreeMapColorProvider *mColorProvider;
    IBOutlet NSTextField *mActiveLeafPathTextField;
    NSImage *mCachedImage;
    NSObject *mMouseTracker;
}

- (MMITreeMap *)treeMap;
- (void)setTreeMap:(MMITreeMap *)treeMap;

- (void)setLabelFont:(NSFont *)font;
- (NSFont *)labelFont;

- (MMITreeMapColorProvider *) colorProvider;
- (void) setColorProvider:(MMITreeMapColorProvider *) colorProvider;

- (MMITreeMapNode *)activeLeaf;
- (void) setActiveLeaf:(MMITreeMapNode *)activeLeaf;

- (void) zoom:(MMITreeMapNode *)node;

- (void) setMouseTracker:(NSObject *)mouseTracker;

- (MMITreeMapViewState) state;
- (void) setState:(MMITreeMapViewState) state;

- (BOOL) calculatingPositions;

- (void) setAnalyzingData:(BOOL)analyzingData;
- (BOOL)isAnalyzingData;

//- (NSString *)activeLeafPath;
//
//- (NSString *)displayedRootPath;

@end

//
//
//

@interface NSObject ( MMITreeMapViewMouseTracking )
- (void) mouseMovedToPoint:(NSPoint)point overNode:(MMITreeMapNode *)node;
- (void) viewWillZoom:(MMITreeMapView *)view toNode:(MMITreeMapNode *)node realZoom:(BOOL)realZoom;
- (void) viewDidZoom:(MMITreeMapView *)view;
@end

//
//
//

